AWSTemplateFormatVersion: 2010-09-09
Transform: 'AWS::Serverless-2016-10-31'
Description: Market Config Adapter

Parameters:
  ApplicationId:
    Type: AWS::SSM::Parameter::Value<String>
    Default: "/Lambda/DiscordSlashBot/ApplicationId"
  ClientSecret:
    Type: AWS::SSM::Parameter::Value<String>
    Default: "/Lambda/DiscordSlashBot/ClientSecret"
  LoginRedirectUri:
    Type: AWS::SSM::Parameter::Value<String>
    Default: "/Lambda/DiscordSlashBot/LoginRedirectUri"
  PublicKey:
    Type: AWS::SSM::Parameter::Value<String>
    Default: "/Lambda/DiscordSlashBot/PublicKey"


Resources:
  ApiGatewayApi:
    Type: 'AWS::Serverless::Api'
    Properties:
      StageName: Prod
      Domain:
        CertificateArn: !ImportValue AwsBoerlageCertificate
        DomainName: "discord-webhook-bot.aws.boerlage.me"
        Route53:
          HostedZoneId: !ImportValue AwsBoerlageZoneId
          IpV6: true

  Lambda:
    Type: 'AWS::Serverless::Function'
    Properties:
      CodeUri: ./src
      Handler: app.handler
      Runtime: nodejs12.x
      Timeout: 30
      Environment:
        Variables:
          APPLICATION_ID: !Ref ApplicationId
          CLIENT_SECRET: !Ref ClientSecret
          LOGIN_REDIRECT_URI: !Ref LoginRedirectUri
          PUBLIC_KEY: !Ref PublicKey
      Events:
        HelloWorld:
          Type: Api
          Properties:
            Path: /{proxy+}
            Method: any
            RestApiId: !Ref ApiGatewayApi
